package net.weasel.Vegetation;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.bukkit.World;
import org.bukkit.block.Biome;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitScheduler;

public class Vegetation extends JavaPlugin
{
	public boolean debugging = false;
	public static Random generator = new Random();
	public static BukkitScheduler timer;
	public static Integer tTask;
	public static Integer OGTask;
	public static Integer timerDelay;
	public static String pluginName = "Vegetation";
	public static String pluginVersion = "1.0";
	public static boolean enableGrass = true;
	public static float grassPerCycle = 0;
	public static float plantsPerCycle = 0;
	public static float grassTick = 0;
	public static float plantTick = 0;
	public static Integer growthRange = 0;
	public static Integer verticalRadius = 5;
	public static Integer overGrowCounter = -1;
	
	public static boolean plantGrowBusy = false;
	public static boolean grassGrowBusy = false;
	public static boolean overgrowBusy = false;
	
	public static boolean enablePlants = true;
	public static boolean enablePumpkins = true;
	public static boolean enableFlowers = true;
	public static boolean enableFungi = true;
	public static boolean enableCacti = true;
	public static boolean enableCanes = true;
		
	public static boolean growForestBiome = true;
	public static boolean growRainforestBiome = true;
	public static boolean growShrublandBiome = true;
	public static boolean growSavannahBiome = true;
	public static boolean growPlainsBiome = true;
	public static boolean growSeasonalForestBiome = true;
	public static Player overGrower = null;
	
	public static String pluginIni = "plugins/Vegetation/Settings.ini";
	
	public static List<Block> grassList = new ArrayList<Block>();
	public static List<Block> plantList = new ArrayList<Block>();
	
	@Override
    public void onEnable() 
    {
		if( new File("plugins/Vegetation/").exists() == false )
		{
			logOutput( "Settings folder does not exist - creating it.. ");
			
			boolean chk = new File("plugins/Vegetation/").mkdir();
			
			if( chk )
				logOutput( "Successfully created folder." );
			else
				logOutput( "Unable to create folder!" );
		}	
		
		if( new File(pluginIni).exists() == false )
		{
			logOutput( "Settings file does not exist - creating a new one.. ");
			
			if( createIniFile() == true )
				logOutput( "Created successfully." );
			else
				logOutput( "Unable to create ini file!" );
		}

		debugging = new File("plugins/Vegetation/debug.txt").exists();
		if( debugging ) logOutput( "debugging is enabled." );
		
        logOutput( pluginName + " v" + pluginVersion + " enabled." );
        
        timer = this.getServer().getScheduler();

        enableGrass = getBooleanSetting( "enableGrass", true );
        enablePlants = getBooleanSetting( "enablePlants", true );
    	enablePumpkins = getBooleanSetting( "enablePumpkins", true );
    	enableFlowers = getBooleanSetting( "enableFlowers", true );
    	enableFungi = getBooleanSetting( "enableFungi", true );
    	enableCacti = getBooleanSetting( "enableCacti", true );
    	enableCanes = getBooleanSetting( "enableCanes", true );

    	growForestBiome = getBooleanSetting( "growForestBiome", true );
    	growRainforestBiome = getBooleanSetting( "growRainforestBiome", true );
    	growShrublandBiome = getBooleanSetting( "growShrublandBiome", true );
    	growSavannahBiome = getBooleanSetting( "growSavannahBiome", true );;
    	growPlainsBiome = getBooleanSetting( "growPlainsBiome", true );
    	growSeasonalForestBiome = getBooleanSetting( "growSeasonalForestBiome", true );

    	verticalRadius = getIntSetting( "verticalRadius", 5 );
        timerDelay = getIntSetting( "growDelay", 10 )*1000;
        growthRange = getIntSetting( "growthRange", 100 );
        grassPerCycle = getFloatSetting( "grassPerCycle", Float.valueOf("20") );
        plantsPerCycle = getFloatSetting( "plantsPerCycle", Float.valueOf("0.5") );
        
        if( enableGrass || enablePlants )
        {
        	tTask = setupTimerTask((timerDelay/1000)*20);
        	
	        logOutput( "Growth cycle set to every "+(timerDelay/1000)+" seconds.");
	        logOutput( "Growth limit: "+growthRange+"(XZ) and " + verticalRadius + "(Y) blocks of players.");
	        logOutput( "Grass is " + ( enableGrass ? "ENABLED" : "DISABLED" ) + " and plants are " + ( enablePlants ? "ENABLED" : "DISABLED" ) );
	        logOutput( grassPerCycle + " grass & " + plantsPerCycle + " plants, each cycle." );
	    }
        else
        {
        	logOutput( "No vegetation is enabled. Disabling plugin." );
            this.getPluginLoader().disablePlugin(this);
        }
    }
    
    @Override
    public void onDisable() 
    {
        logOutput( "Plugin disabled: "+pluginName+" version "+pluginVersion);
    }
    
    public String[] getSetting( String which )
    {
        return( getSettingValue(pluginIni, which, "10", "" ) );
    }

    public boolean getBooleanSetting( String which, boolean dValue )
    {
    	boolean retVal;
    	
    	String dString = ( dValue ? "true" : "false" );
    	
        if( getSettingValue(pluginIni, which, dString, "" )[0].equalsIgnoreCase("true") )
        	retVal = true;
        else
        	retVal = false;
        
        return( retVal );
    }
    
    public int setupTimerTask( Integer interval )
    {
    	Integer task = timer.scheduleAsyncRepeatingTask(this, growTask, interval, interval );
        return task;
    }
    
    public void setupOvergrowTask( Player who )
    {
    	if( overgrowBusy == false )
    	{
			who.sendMessage( "Right away, Totoro-san! ^_^ Prepare for the lag.." );
			overGrowCounter = 20;
			who.getServer().getWorlds().get(0).setTime(0);
			overGrower = who;
    		OGTask = timer.scheduleAsyncRepeatingTask(this, overgrowTask, 1, 1 );
    		overgrowBusy = true;
    	}
    	else
    	{
    		who.sendMessage( "We're already in the middle of an overgrowth cycle." );
    		who.sendMessage( "Please be patient." );
    	}
    		
    }
    
    public Runnable growTask = new Runnable()
    {
    	@Override
		public void run() 
		{
    		try
    		{
				World currentWorld = null;
			 
				for( Integer W = 0; W < getServer().getWorlds().size(); W++ )
				{
					currentWorld = getServer().getWorlds().get(W);
				
					if( getServer().getOnlinePlayers().length > 0 && currentWorld.getTime() < 12000 )
					{
						grassTick += grassPerCycle;
							
						if( grassTick >= 1 )
						{
							if( enableGrass == true ) growTheGrass();
							grassTick = 0;
						}
	
						plantTick += plantsPerCycle;
						
						if( plantTick >= 1 )
						{
							if( enablePlants == true ) growThePlants(plantTick);
							plantTick = 0;
						}
					}
				}
			}
	    	catch( Exception e )
	    	{
	    		// Do nothing..
	    	}
		}
    };
        
    public Runnable overgrowTask = new Runnable()
    {
    	@Override
		public void run() 
		{
    		try
    		{
				World currentWorld = null;
			 
				for( Integer W = 0; W < getServer().getWorlds().size(); W++ )
				{
					currentWorld = getServer().getWorlds().get(W);
				
					if( getServer().getOnlinePlayers().length > 0 && currentWorld.getTime() < 12000 )
					{
						grassTick += grassPerCycle;
							
						if( grassTick >= 1 )
						{
							if( enableGrass == true ) growTheGrass();
							grassTick = 0;
						}
	
						plantTick += plantsPerCycle;
						
						if( plantTick >= 1 )
						{
							if( enablePlants == true ) growThePlants(plantTick);
							plantTick = 0;
						}
					}
				}
    		}
			
    		catch( Exception e )
			{
				// Do nothing..
			}
		}
    };
        
    public Integer getIntSetting( String item, Integer dValue )
    {
    	Integer retVal = Integer.parseInt( getSettingValue(pluginIni, item, dValue.toString(), "" )[0]);
    	return retVal;
    }

    public Float getFloatSetting( String item, Float dValue )
    {
    	Float retVal = Float.valueOf(getSettingValue(pluginIni, item, dValue.toString(), "" )[0]);
    	return retVal;
    }

    public boolean createIniFile()
    {
    	boolean retVal = false;
    	
    	try 
    	{
			FileWriter outFile = new FileWriter(pluginIni);
			PrintWriter outP = new PrintWriter(outFile);
			
			outP.println( "growDelay=10" );
			outP.println( "growthRange=100" );
			outP.println( "verticalRadius=5" );
			outP.println( "enableGrass=true" );
			outP.println( "enablePlants=true" );
			outP.println( "enableFlowers=true" );
			outP.println( "enableFungi=true" );
			outP.println( "enablePumpkins=true" );
			outP.println( "enableCacti=true" );
			outP.println( "enableCanes=true" );
			outP.println( "grassPerCycle=20" );
			outP.println( "plantsPerCycle=0.5" );
			outP.println( "growForestBiome=true" );
			outP.println( "growRainforestBiome=true" );
			outP.println( "growShrublandBiome=true" );
			outP.println( "growSavannahBiome=true" );
			outP.println( "growPlainsBiome=true" );
			outP.println( "growSeasonalForestBiome=true" );
			
			outP.close();
			retVal = true;
		} 
    	catch (IOException e) 
    	{
			logOutput( "Error writing to ini file." );
			retVal = false;
			e.printStackTrace();
		}
		
		return retVal;
    }
    
	public boolean onCommand(CommandSender sender, Command command, String commandLabel, String[] args) 
    {
    	String pCommand = command.getName().toLowerCase();
    	
    	if( pCommand.equals("mow") )
    	{
    		mowTheGrass( (Player) sender );
    		sender.sendMessage( "You have cut down the grass." );
    	}
    	
    	if( pCommand.equals("growplants") )
    	{
    		growThePlants( ( plantsPerCycle < 1 ? 1 : plantsPerCycle ) );
    		sender.sendMessage( "Growing the plants.." );
    	}
    	
    	if( pCommand.equals("growgrass") )
    	{
    		growTheGrass();
    		sender.sendMessage( "Growing the grass.." );
    	}
    	
    	if( pCommand.equals("overgrow") )
    	{
			setupOvergrowTask( (Player) sender );
    	}

    	if( pCommand.equals("grow") )
    	{
    		growThePlants( ( plantsPerCycle < 1 ? 1 : plantsPerCycle ) );
    		growTheGrass();
    		sender.sendMessage( "Growing everything.." );
    	}

    	return true;
    }
	
    public void growTheGrass()
    {
    	if( grassGrowBusy == true ) 
    	{
    		return;
    	}
    	else
    	{
    		grassGrowBusy = true;
    		
	    	Player player = null;
	    	Integer I = 0;
	    	Integer  V = 0;
	    	
			while( I < this.getServer().getOnlinePlayers().length ) 
			{
				player = this.getServer().getOnlinePlayers()[I];
				Block currentBlock = null;
				
				for( Integer C = 0; C < grassPerCycle; C++ )
				{
					currentBlock = getRandomGrassBlock( player, growthRange );
		
					try
					{
						V = currentBlock.getData() + 1;
							
						if( V > 10 ) V = 10;
			    
						if( debugging ) logOutput( "Adjusting block " + currentBlock.getX() + "," + currentBlock.getY() + "," + currentBlock.getZ() );

						currentBlock.setData( (byte)(int)V );
					}
					catch( Exception e )
					{
						// Do nothing..
					}
				}
				
				I++;
			}
			
			grassGrowBusy = false;

			if( overGrowCounter > 0 )
			{
				overGrowCounter--;
    		
				if( overGrowCounter < 1 )
				{
					timer.cancelTask(OGTask);
					overGrower.sendMessage( "Overgrowth cycle completed." );
					overGrower = null;
					overgrowBusy = false;
				}
			}
    	}
    }

    public Block getRandomGrassBlock( Player player, Integer range )
    {
    	Block retVal = null;
    	
    	double pX = player.getLocation().getX();
    	double pZ = player.getLocation().getZ();
    	
    	double minX = (pX - (range / 2));
    	double minZ = (pZ - (range / 2));

    	Block currentBlock;
    	double tX, tZ;

    	while( retVal == null )
    	{
    		tX = minX + generator.nextInt(range);
    		tZ = minZ + generator.nextInt(range);

        	currentBlock = getTopBlock( player.getWorld(), tX, tZ );
			
        	if( currentBlock != null )
        	{
	        	if( ( ( currentBlock.getTypeId() == 2 ) 
	        	   && ( currentBlock.getBiome() == Biome.FOREST && growForestBiome == true )
	        	   || ( currentBlock.getBiome() == Biome.RAINFOREST && growRainforestBiome == true )
	        	   || ( currentBlock.getBiome() == Biome.PLAINS && growPlainsBiome == true )
	        	   || ( currentBlock.getBiome() == Biome.SAVANNA && growSavannahBiome == true )
	        	   || ( currentBlock.getBiome() == Biome.SHRUBLAND&& growShrublandBiome == true )
	        	   || ( currentBlock.getBiome() == Biome.SEASONAL_FOREST && growSeasonalForestBiome == true )
				   )
	     	       && currentBlock.getRelative(BlockFace.UP).getTypeId() == 0 
	     	    )
	        		retVal = currentBlock;
	        	else
	        		retVal = null;
        	}
    	}

    	if( debugging ) logOutput( "Found grass block: " + retVal.getX() + "," + retVal.getY() + "," + retVal.getZ() );
    	
    	return( retVal );
    }

    public Block getRandomPlantBlock( Player player )
    {
    	Block currentBlock = null;
    	
    	ArrayList<Block> plantBlocks = new ArrayList<Block>();
    	
    	double pX = player.getLocation().getX();
    	double pZ = player.getLocation().getZ();
    	
    	Integer minX = (int) (pX - (growthRange / 2));
    	Integer minZ = (int) (pZ - (growthRange / 2));
    	Integer maxX = (int) (pX + (growthRange / 2));
    	Integer maxZ = (int) (pZ + (growthRange / 2));

    	for( Integer X = minX; X <= maxX; X++ )
    	{
    		for( Integer Z = minZ; Z <= maxZ; Z++ )
    		{
    			currentBlock = getTopBlock(player.getWorld(), X, Z );
    			    			
            	if( currentBlock != null )
            	{
        			if( ( ( currentBlock.getTypeId() == 37 && enableFlowers == true )
	    	    	   || ( currentBlock.getTypeId() == 38 && enableFlowers == true )
	    	    	   || ( currentBlock.getTypeId() == 39 && enableFungi == true )
	    	    	   || ( currentBlock.getTypeId() == 40 && enableFungi == true )
	    	    	   || ( currentBlock.getTypeId() == 86 && enablePumpkins == true ) 
	    	    	   || ( currentBlock.getTypeId() == 81 && enableCacti == true ) 
	    	    	   || ( currentBlock.getTypeId() == 83 && enableCanes == true ) 
	    	    	    )
	    	    	 && ( ( currentBlock.getBiome() == Biome.FOREST && growForestBiome == true )
	    	    	    || ( currentBlock.getBiome() == Biome.RAINFOREST && growRainforestBiome == true )
	    	    	    || ( currentBlock.getBiome() == Biome.PLAINS && growPlainsBiome == true )
	    	    	    || ( currentBlock.getBiome() == Biome.SAVANNA && growSavannahBiome == true )
	    	    		|| ( currentBlock.getBiome() == Biome.SHRUBLAND&& growShrublandBiome == true )
	    	    		|| ( currentBlock.getBiome() == Biome.SEASONAL_FOREST && growSeasonalForestBiome == true )
	    	    		)
	    	    	  )
	    			{
            			plantBlocks.add(currentBlock);
	    			}
            	}
    		}
    	}

    	if( plantBlocks.size() > 0 )
    	{
    		Integer R = generator.nextInt( plantBlocks.size() );

    		return( plantBlocks.get(R) );
    	}
    	else
    		return( null );
    }

    public Block getTopBlock( World world, double X, double Z )
    {
    	Block retVal = null;
    	double Y = 127;
    	boolean exitLoop = false;
    	Block currentBlock = null;
    	
    	while( Y > 0 && exitLoop == false )
    	{
    		try
    		{
    			currentBlock = world.getBlockAt((int)X,(int)Y,(int)Z);
    		}
    		catch( Exception e )
    		{
    			retVal = null;
    			exitLoop = true;
    			break;
    		}
    		
    		if( currentBlock.getTypeId() != 0 && currentBlock.getTypeId() != 17 && currentBlock.getTypeId() != 18 )
    		{
    			retVal = currentBlock;
    			exitLoop = true;
    		}
    		else
    		{
    			Y--;
    		}
    	}
    	
    	return retVal;
    }
    
    public void growThePlants( double howMany )
    {
    	if( plantGrowBusy == true )
    		return;
    	else
    	{
    		plantGrowBusy = true;
    		
			Block currentBlock = null;
	    	Player player = null;
	    	Integer I = 0;
	    	int attempts = 0;
	    	
			while( I < this.getServer().getOnlinePlayers().length ) 
			{
				player = this.getServer().getOnlinePlayers()[I];
				
				for( Integer C = 0; C < howMany; C++ )
				{
					attempts = 0;
					
					currentBlock = getRandomPlantBlock( player );
					
					while( currentBlock == null && attempts <= 100 )
					{
						currentBlock = getRandomPlantBlock( player );
						attempts++;
					}
					
					if( attempts > 100 ) 
						currentBlock = null;
					else
					{
						if( debugging ) logOutput( "Found plant block: " + currentBlock.getTypeId() + " plant at " + currentBlock.getX() + "," + currentBlock.getY() + "," + currentBlock.getZ() + "." );

						try
						{
							Block RB = getRandomAdjacentEmptyDirtBlock( currentBlock ).getRelative(BlockFace.UP);
							Block targetBlock = getTopBlock(player.getWorld(), (double)RB.getX(), (double)RB.getZ() ).getRelative(BlockFace.UP);
						
							if( targetBlock != null )
							{
								if( targetBlock.getTypeId() == 0 )
								{
									if( debugging ) logOutput( "Spreading " + currentBlock.getTypeId() + " plant at " + targetBlock.getX() + "," + targetBlock.getY() + "," + targetBlock.getZ() + "." );
							
									targetBlock.setType(currentBlock.getType() );
								}
							}
						}
						catch( Exception e )
						{
							// Do nothing..
						}
					}
					
					plantGrowBusy = false;
				}
				
				I++;
			}
			
			if( overGrowCounter > 0 )
			{
				overGrowCounter--;
    		
				if( overGrowCounter < 1 )
				{
					timer.cancelTask(OGTask);
					overGrower.sendMessage( "Overgrowth cycle complete." );
					overGrower = null;
					overgrowBusy = false;
				}
			}
    	}
    }
    
    public void mowTheGrass( Player player )
    {
    	Integer R = Math.round( growthRange / 2 );
    	double pX = player.getLocation().getX();
    	double pZ = player.getLocation().getZ();
    	    	
    	Block currentBlock = null;
    	
    	for( double X = (pX-R); X <= (pX+R); X++ )
    	{
    		for( double Z = (pZ-R); Z <= (pZ+R); Z++ )
    		{
    			currentBlock = getTopBlock(player.getWorld(), X, Z );
    			
    			if( currentBlock.getData() > 1 && currentBlock.getTypeId() == 2 ) 
    			{
    				currentBlock.setData( (byte) 1 );
    			}
    		}
    	}
    }
    
    public ArrayList<Block> getAdjacentBlocks( Block targetBlock )
    { 	
    	ArrayList<Block> blockList = new ArrayList<Block>();
    	
    	Integer tX = targetBlock.getX();
    	Integer tY = targetBlock.getY();
    	Integer tZ = targetBlock.getZ();
    	
    	Integer minX = tX - 1, maxX = tX + 1;
    	Integer minY = tY - 1, maxY = tY + 1;
    	Integer minZ = tZ - 1, maxZ = tZ + 1;
    	
    	for( int X = minX; X <= maxX; X++ )
    	{
    		for( int Y = minY; Y <= maxY; Y++ )
    		{
    			for( int Z = minZ; Z <= maxZ; Z++ )
    			{
    				if( X != tX && Y != tY && Z != tZ )
    					blockList.add( targetBlock.getWorld().getBlockAt(X,Y,Z) );
    			}
    		}
    	}
    	
    	return blockList;
    }
    
	public Block getRandomAdjacentEmptyDirtBlock(Block targetBlock )
    {
    	Block retVal = null;
    	Block block = null;
    	ArrayList<Block> tBlocks = new ArrayList<Block>();
    	ArrayList<Block> vBlocks = new ArrayList<Block>();

    	tBlocks = getAdjacentBlocks(targetBlock);

    	for( int X = 0; X < tBlocks.size(); X++ )
    	{
    		block = tBlocks.get(X);
    		
    		if( block.getTypeId() == 2 && block.getRelative(BlockFace.UP).getTypeId() == 0 )
    		{
    			vBlocks.add( block );
    		}
    	}
    	
    	if( vBlocks.size() > 0 )
    	{
			Integer R = generator.nextInt(vBlocks.size());
			retVal = vBlocks.get(R);
    	}
    	
    	return retVal;
    }
    
    public String[] getSettingValue(String fileName, String optionName, String defaultValue, String splitValue)
    {
    	Boolean gotLine; // Verification variable
    	String[] returnValue = new String[100]; // Settings max at 100 values
    	String curLine;
    	
    	gotLine = false; // We don't have the settings found yet
    	
    	if( new File(fileName).exists() == false )
    	{
    		return( new String("File not found.ZQX").split("ZQX") );
    	}
		if(splitValue.equals("")) {
			splitValue = "afs4wfa3waawfa3dogrsijkge5ssioeguhwar3awwa3rar";
		}
    	
        try {
        	// Get the line from the file
			FileInputStream fstream = new FileInputStream(fileName);
			BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
			
			while(in.ready()) 
			{
				curLine = in.readLine().toString();
				if(curLine.split("=", 2)[0].equalsIgnoreCase(optionName)) {
					returnValue = new String[100];
					returnValue = curLine.split("=", 2)[1].split(splitValue);
					gotLine = true;
				}
			}
			
			in.close();
			
			// If the line does not exist, create it
			if(!gotLine) 
			{
                returnValue = defaultValue.split(splitValue);
                FileOutputStream out;
                PrintStream p;
                try {
	                out = new FileOutputStream(fileName, true);
	                p = new PrintStream( out );
	                p.println (optionName+"="+defaultValue);
	                p.close();
                } catch (Exception e) {
                	logOutput("Error writing to file");
                }
			}
		}
        catch (Exception e) {
        	logOutput("-=-");
        	logOutput("File input error: "+e.toString());
        	logOutput("File input error: "+e.getStackTrace().toString());
        	logOutput("-=-");
		}
		finally {
		}
		
		return returnValue;
    }

    public void logOutput(String text)
    {
    	System.out.println( "[" + pluginName + "]: " + text );
    }
}
